Subject: Re: orphan blob or what?

From: bruce <[email-masked]>
Date: Sat, 10 Nov 2012 16:32:02 -0800

Tomas Carnecky <[email-masked]> writes:

> On Fri, 09 Nov 2012 11:37:04 -0800, bruce <[email-masked]> wrote:
>> Tomas Carnecky <[email-masked]> writes:
>> 
>> Just idiocy on my part. Thanks.
>> 
>> > On Thu, 08 Nov 2012 16:24:36 -0800, bruce <[email-masked]> wrote:
>> >> In today's and older clones of https://github.com/mirrors/linux.git I
>> >> find this object, 6fa98ea0ae40f9a38256f11e5dc270363f785aee, that I can't
>> >> figure out how to eliminate^h^h^h^h^h^h^h^h^hget rid of. I don't see it
>> >> in 'git fsck', 'git gc --aggressive --prune' doesn't seem to prune it,
>> >> can't see it via 'git log'. And yet
>> >> 
>> >> linux/.git/objects/pack$ git verify-pack -v *.idx | grep 6fa98ea0ae40f9a38256f11e5dc270363f785aee
>> >> 6fa98ea0ae40f9a38256f11e5dc270363f785aee blob   1519697 124840 515299673
>> >> 8231eaa31ce1107c1463deb6ec33f61618aedbb9 blob   67 63 515424513 1 6fa98ea0ae40f9a38256f11e5dc270363f785aee
>> >> f21a8c1b9d47736fa4e27def66f04b9fe2b4bc53 blob   90 83 515424576 1 6fa98ea0ae40f9a38256f11e5dc270363f785aee
>> >
>> > Commit dee0bb9 (ASoC: Mark WM8962 Additional Control 4 register as volatile,
>> > 2010-09-29) references this blob.
>
> It wasn't easy to find the commit. First I figured out at which path that file
> was stored. Using git log -S'wm8962_reg[WM8962_MAX_REGISTER + 1]' I quickly
> determined that the file was somewhere in sound/, more specifically
> sound/soc/codecs/wm8962-tables.c. However a 'git log --
> sound/soc/codecs/wm8962-tables.c' did not show any commit. That was strange,
> because 'git log -S'WM8962_MAX_REGISTER + 1' --name-status --
> sound/soc/codecs/' clearly shows that the file existed at some point in the
> past. The commit is hidden from a simple 'git log' due to 'History
> Simplification'. See the git-log man page. I added --full-history -p to the log
> command, and searched in the pager for '6fa98e'. That revealed the commit which
> references that blob:
>
>     git log --full-history -p -- sound/soc/codecs/wm8962-tables.c

Thanks very much for the elucidation. I really must RTFMs. Only 44.786
Kib lines. Porcelain (mostly) first. I just can't eliminate the reading
I need to do.

FWIW, I was somewhat perplexed by searching for
c969f19f8fd17e600a16fe91aab66d86936cce0a in 'gitk -all'. It doesn't find
it BUT if I use --select-commit=c969f19f8fd17e600a16fe91aab66d86936cce0a
then positions to it. If I position away again it again can't find
it. Bother!

BTW, this was all occasioned by looking for unused large packed blobs as
an educational exercise.

Thanks again,
Bruce